# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.48.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from synctera_client import schemas  # noqa: F401


class Lookup3dsResponse(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Details for an External Card Transfer 3-D Secure Authentication lookup response
    """


    class MetaOapg:
        required = {
            "id",
            "status",
        }
        
        class properties:
            id = schemas.UUIDSchema
            
            
            class status(
                schemas.EnumBase,
                schemas.StrSchema
            ):
                
                @schemas.classproperty
                def SUCCESS(cls):
                    return cls("SUCCESS")
                
                @schemas.classproperty
                def FAILED(cls):
                    return cls("FAILED")
                
                @schemas.classproperty
                def CHALLENGE_REQUIRED(cls):
                    return cls("CHALLENGE_REQUIRED")
                
                @schemas.classproperty
                def NOT_ENROLLED(cls):
                    return cls("NOT_ENROLLED")
                
                @schemas.classproperty
                def UNKNOWN(cls):
                    return cls("UNKNOWN")
            challenge_payload = schemas.StrSchema
            challenge_url = schemas.StrSchema
            processor_transaction_id = schemas.StrSchema
            __annotations__ = {
                "id": id,
                "status": status,
                "challenge_payload": challenge_payload,
                "challenge_url": challenge_url,
                "processor_transaction_id": processor_transaction_id,
            }
    
    id: MetaOapg.properties.id
    status: MetaOapg.properties.status
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["status"]) -> MetaOapg.properties.status: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["challenge_payload"]) -> MetaOapg.properties.challenge_payload: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["challenge_url"]) -> MetaOapg.properties.challenge_url: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["processor_transaction_id"]) -> MetaOapg.properties.processor_transaction_id: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["id", "status", "challenge_payload", "challenge_url", "processor_transaction_id", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["status"]) -> MetaOapg.properties.status: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["challenge_payload"]) -> typing.Union[MetaOapg.properties.challenge_payload, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["challenge_url"]) -> typing.Union[MetaOapg.properties.challenge_url, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["processor_transaction_id"]) -> typing.Union[MetaOapg.properties.processor_transaction_id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["id", "status", "challenge_payload", "challenge_url", "processor_transaction_id", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        id: typing.Union[MetaOapg.properties.id, str, uuid.UUID, ],
        status: typing.Union[MetaOapg.properties.status, str, ],
        challenge_payload: typing.Union[MetaOapg.properties.challenge_payload, str, schemas.Unset] = schemas.unset,
        challenge_url: typing.Union[MetaOapg.properties.challenge_url, str, schemas.Unset] = schemas.unset,
        processor_transaction_id: typing.Union[MetaOapg.properties.processor_transaction_id, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'Lookup3dsResponse':
        return super().__new__(
            cls,
            *_args,
            id=id,
            status=status,
            challenge_payload=challenge_payload,
            challenge_url=challenge_url,
            processor_transaction_id=processor_transaction_id,
            _configuration=_configuration,
            **kwargs,
        )
